/* Sistemas Integrados TECNISA

Nome: 9803_CDPTRGO_LOG_CDP_INSUMETAPA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela INSUMETAPA 
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              INSUMETAPA para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_INSUMETAPA
AFTER DELETE OR INSERT OR UPDATE
ON INSUMETAPA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(50);
  V_DSREMOTEHOST VARCHAR2(50);
  V_DSSERVERRDM  VARCHAR2(50);
  V_DSSERVMETHOD VARCHAR2(250);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(6000);
  V_LENGTH       INTEGER;
  V_CONT_LENGTH  INTEGER;
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(250);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);


   IF INSERTING THEN

      IF :NEW.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Filial=' || NVL(:NEW.CDFILIAL,'') || ' ';
      END IF;

      IF :NEW.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ';
      END IF;

      IF :NEW.CDPROCFABRIC IS NOT NULL THEN
         V_DESC := V_DESC || 'CdProcFabric=' || NVL(:NEW.CDPROCFABRIC,'') || ' ';
      END IF;

      IF :NEW.CDETAPAPROD IS NOT NULL THEN
         V_DESC := V_DESC || 'CdEtapaProduo= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
      END IF;

      IF :NEW.CDPRODINSUMO IS NOT NULL THEN
      V_DESC := V_DESC || 'CdProdInsumo= ' || NVL(:NEW.CDPRODINSUMO,'') || ' ';
      END IF;

      IF :NEW.CDTIPOINSU IS NOT NULL THEN
         V_DESC := V_DESC || 'CdTipoInsumo= ' || :NEW.CDTIPOINSU || ' ';
      END IF;

      IF :NEW.IDUTAPRREQET IS NOT NULL THEN
         V_DESC := V_DESC || 'Ut. Aprov. Req= '
                          || NVL(:NEW.IDUTAPRREQET,'') || ' ';
      END IF;

      IF :NEW.QTINSUMETAPA IS NOT NULL THEN
         V_DESC := V_DESC || 'QtInsumEtapa= ' || TO_CHAR(:NEW.QTINSUMETAPA) || ' ';
	   END IF;

      IF :NEW.QTRENDINSU IS NOT NULL THEN
         V_DESC := V_DESC || 'QtRendInsu= ' || TO_CHAR(:NEW.QTRENDINSU) || ' ';
      END IF;

      IF :NEW.IDSEMIACETAP IS NOT NULL THEN
         V_DESC := V_DESC || 'IdSemiAcEtap= ' || :NEW.IDSEMIACETAP || ' ';
      END IF;

      IF :NEW.IDLOTEPRETAP IS NOT NULL THEN
         V_DESC := V_DESC || 'IdLotePrEtap= ' || :NEW.IDLOTEPRETAP || ' ';
	   END IF;

      IF :NEW.QTBRUTINSETP IS NOT NULL THEN
         V_DESC := V_DESC || 'QtBrutInsEtP= ' || TO_CHAR(:NEW.QTBRUTINSETP) || ' ';
      END IF;

      IF :NEW.VRPRENINSETP IS NOT NULL THEN
         V_DESC := V_DESC || 'VrPRenInsEtp= ' || TO_CHAR(:NEW.VRPRENINSETP) || ' ';
      END IF;

      IF :NEW.IDTIPOPROPOR IS NOT NULL THEN
         V_DESC := V_DESC || 'IdTipoPropor= ' || :NEW.IDTIPOPROPOR || ' ';
      END IF;

      IF :NEW.IDTIPOARREDO IS NOT NULL THEN
         V_DESC := V_DESC || 'IdTipoArredo= ' || :NEW.IDTIPOARREDO || ' ';
      END IF;

      IF :NEW.IDSUBOPINSU IS NOT NULL THEN
         V_DESC := V_DESC || 'IdSubOPInsu= '    || :NEW.IDSUBOPINSU || ' ' ;
      END IF;

      V_ITPESQ := SUBSTR(:NEW.CDFILIAL||:NEW.CDPRODUTO||:NEW.CDPROCFABRIC||:NEW.CDETAPAPROD||:NEW.CDPRODINSUMO, 1, 80);

      V_IDTIPOOPER := '1';
      V_CDFILLOGOPER := :NEW.CDFILIAL;

   ELSE

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial=' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;

         IF (:NEW.CDPROCFABRIC <> :OLD.CDPROCFABRIC) THEN
            V_DESC := V_DESC || 'CdProcFabric=' || NVL(:NEW.CDPROCFABRIC,'') || ' ';
         END IF;

         IF (:NEW.CDETAPAPROD <> :OLD.CDETAPAPROD) THEN
            V_DESC := V_DESC || 'CdEtapaProduo= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF (:NEW.CDPRODINSUMO <> :OLD.CDPRODINSUMO) THEN
            V_DESC := V_DESC || 'CdProdInsumo= ' || NVL(:NEW.CDPRODINSUMO,'') || ' ';
         END IF;

         IF (NVL(:NEW.CDTIPOINSU,'-1') <> NVL(:OLD.CDTIPOINSU,'-1')) THEN
            V_DESC := V_DESC || 'CdTipoInsumo= ' || :NEW.CDTIPOINSU || ' ';
         END IF;

         IF (:NEW.IDUTAPRREQET <> :OLD.IDUTAPRREQET) THEN
            V_DESC := V_DESC || 'Ut. Aprov. Req= '
                             || NVL(:NEW.IDUTAPRREQET,'') || ' ';
         END IF;

         IF (NVL(:NEW.QTINSUMETAPA,'-1') <> NVL(:OLD.QTINSUMETAPA,'-1')) THEN
            V_DESC := V_DESC || 'QtInsumEtapa= ' || TO_CHAR(:NEW.QTINSUMETAPA) || ' ';
         END IF;

         IF (NVL(:NEW.QTRENDINSU,'-1') <> NVL(:OLD.QTRENDINSU,'-1')) THEN
            V_DESC := V_DESC || 'QtRendInsu= ' || TO_CHAR(:NEW.QTRENDINSU) || ' ';
         END IF;

         IF (:NEW.IDSEMIACETAP <> :OLD.IDSEMIACETAP) THEN
            V_DESC := V_DESC || 'IdSemiAcEtap= ' || :NEW.IDSEMIACETAP || ' ';
	      END IF;

         IF (:NEW.IDLOTEPRETAP <> :OLD.IDLOTEPRETAP) THEN
            V_DESC := V_DESC || 'IdLotePrEtap= ' || :NEW.IDLOTEPRETAP || ' ';
	      END IF;

         IF (NVL(:NEW.QTBRUTINSETP,'-1') <> NVL(:OLD.QTBRUTINSETP,'-1')) THEN
            V_DESC := V_DESC || 'QtBrutInsEtP= ' || TO_CHAR(:NEW.QTBRUTINSETP) || ' ';
         END IF;

         IF (NVL(:NEW.VRPRENINSETP,'-1') <> NVL(:OLD.VRPRENINSETP,'-1')) THEN
            V_DESC := V_DESC || 'VrPRenInsEtp= ' || TO_CHAR(:NEW.VRPRENINSETP) || ' ';
         END IF;

         IF (:NEW.IDTIPOPROPOR <> :OLD.IDTIPOPROPOR) THEN
            V_DESC := V_DESC || 'IdTipoPropor= ' || :NEW.IDTIPOPROPOR || ' ';
         END IF;

         IF (:NEW.IDTIPOARREDO <> :OLD.IDTIPOARREDO) THEN
            V_DESC := V_DESC || 'IdTipoArredo= ' || :NEW.IDTIPOARREDO || ' ';
         END IF;

         IF (:NEW.IDSUBOPINSU <> :OLD.IDSUBOPINSU) THEN
            V_DESC := V_DESC || 'IdSubOPInsu= '    || :NEW.IDSUBOPINSU || ' ' ;
         END IF;

         V_ITPESQ := SUBSTR(:NEW.CDFILIAL||:NEW.CDPRODUTO||:NEW.CDPROCFABRIC||:NEW.CDETAPAPROD||:NEW.CDPRODINSUMO, 1, 80);

         V_IDTIPOOPER := '2';
         V_CDFILLOGOPER := :NEW.CDFILIAL;

      END IF;

      IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial=' || NVL(:OLD.CDFILIAL,'') || ' ';
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ';
         END IF;

         IF :OLD.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric=' || NVL(:OLD.CDPROCFABRIC,'') || ' ';
         END IF;

         IF :OLD.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProduo= ' || NVL(:OLD.CDETAPAPROD,'') || ' ';
         END IF;

         IF :OLD.CDPRODINSUMO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdInsumo= ' || NVL(:OLD.CDPRODINSUMO,'') || ' ';
         END IF;

         IF :OLD.CDTIPOINSU IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoInsumo= ' || :OLD.CDTIPOINSU || ' ';
         END IF;

         IF :OLD.IDUTAPRREQET IS NOT NULL THEN
            V_DESC := V_DESC || 'Ut. Aprov. Req= '
                             || NVL(:OLD.IDUTAPRREQET,'') || ' ';
         END IF;

         IF :OLD.QTINSUMETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'QtInsumEtapa= ' || TO_CHAR(:OLD.QTINSUMETAPA) || ' ';
     	   END IF;

         IF :OLD.QTRENDINSU IS NOT NULL THEN
            V_DESC := V_DESC || 'QtRendInsu= ' || TO_CHAR(:OLD.QTRENDINSU) || ' ';
      	END IF;

         IF :OLD.IDSEMIACETAP IS NOT NULL THEN
            V_DESC := V_DESC || 'IdSemiAcEtap= ' || :OLD.IDSEMIACETAP || ' ';
         END IF;

         IF :OLD.IDLOTEPRETAP IS NOT NULL THEN
            V_DESC := V_DESC || 'IdLotePrEtap= ' || :OLD.IDLOTEPRETAP || ' ';
	      END IF;

         IF :OLD.QTBRUTINSETP IS NOT NULL THEN
            V_DESC := V_DESC || 'QtBrutInsEtP= ' || TO_CHAR(:OLD.QTBRUTINSETP) || ' ';
         END IF;

         IF :OLD.VRPRENINSETP IS NOT NULL THEN
            V_DESC := V_DESC || 'VrPRenInsEtp= ' || TO_CHAR(:OLD.VRPRENINSETP) || ' ';
         END IF;

         IF :OLD.IDTIPOPROPOR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTipoPropor= ' || :OLD.IDTIPOPROPOR || ' ';
         END IF;

         IF :OLD.IDTIPOARREDO IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTipoArredo= ' || :OLD.IDTIPOARREDO || ' ';
         END IF;

         IF :OLD.IDSUBOPINSU IS NOT NULL THEN
            V_DESC := V_DESC || 'IdSubOPInsu= '    || :OLD.IDSUBOPINSU || ' ' ;
         END IF;

         V_ITPESQ := SUBSTR(:OLD.CDFILIAL||:OLD.CDPRODUTO||:OLD.CDPROCFABRIC||:OLD.CDETAPAPROD||:OLD.CDPRODINSUMO, 1, 80);

         V_IDTIPOOPER := '3';
         V_CDFILLOGOPER := :OLD.CDFILIAL;

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                       VALUES  ('INSUMETAPA', SYSDATE ,    NVL(SUBSTR(V_NMOPERADOR,1,40),' '),
                                V_IDTIPOOPER,   V_GRAV_DESC, V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_INSUMETAPA','5.07.001'); END;
/ 
